#!/usr/bin/perl -w

# This script wraps the source, reference, and MT output files 
# in the XML format required by the NIST Bleu evaluation script.


$file = $ARGV[0];
$fileType = $ARGV[1]; # should be refset, srcset or tstset
$sourceLang = $ARGV[2];
$targetLang = $ARGV[3];
$testSetName = $ARGV[4];

$sysid = "";
if($fileType =~ /tstset/) {
    $sysid = "sysid=\"$ARGV[5]\"";
} elsif($fileType =~ /refset/) {
   $sysid = "sysid=\"ref\"";
}

$zip = 0;
if($file =~ /gz$/) {
    `gunzip $file`;
    $file =~ s/.gz$//;
    $zip = 1;

}

print "<$fileType setid=\"$testSetName\" srclang=\"$sourceLang\" trglang=\"$targetLang\" $sysid>\n";
print "<DOC docid=\"$testSetName\" $sysid>\n";

$counter = 1;
open(FILE, $file) or die("Couldn't open $file\n");
while($line = <FILE>) {
    chomp $line;
    print "<seg id=$counter> $line </seg>\n";
    $counter++;
}
print "</DOC>\n";
print "</$fileType>";

if($zip == 1) {
    `gzip $file`;
}

