package clsp.aligner;

import clsp.util.Alignment;
import clsp.util.SentencePair;
import clsp.util.SentencePairReader.PairDepot;

public class HeuristicModel extends Model {

	public HeuristicModel(boolean reverse) {
		super(reverse);
	}

	@Override
	public void observe(SentencePair pair) {
		// Nothing to do.  Everything is computed in initModel.
	}

	@Override
	public Alignment score(SentencePair pair) {
		Alignment alignment = new Alignment(pair);
		for (int e = 0; e < alignment.getEnglishLength(); e++) {
			for (int f = 0; f < alignment.getForeignLength(); f++) {
				String eword = pair.getEnglishWords().get(e);
				String fword = pair.getForeignWords().get(f);
				double dice = wordPairStats.dice(reverse, eword, fword);
				alignment.setStrength(e, f, dice);
			}
		}
		return alignment;
	}

	@Override
	public void completeIteration(int i) {
	}

	@Override
	protected void initModel(PairDepot trainingPairs) {
		wordPairStats.computeStats(); // This computes counts of all words and joint counts
	}

}
