package clsp.aligner;

import clsp.util.Alignment;
import clsp.util.SentencePair;
import clsp.util.SentencePairReader.PairDepot;
import clsp.util.Logger;

public abstract class Model {
	boolean reverse;
	String name;
	WordPairStats wordPairStats;
	
	public Model(boolean reverse) {
		super();
		this.reverse = reverse;
		this.name = this.getClass().getCanonicalName() + (reverse ? "_reverse" : "");
	}

	public void initialize(PairDepot trainingPairs) {
	  Logger.track("Counting words");
		wordPairStats = new WordPairStats(trainingPairs);
		Logger.end_track();
		initModel(trainingPairs);
	}

	protected abstract void initModel(PairDepot trainingPairs);
	
	public abstract void observe(SentencePair pair);

	public abstract void completeIteration(int i);

	public abstract Alignment score(SentencePair pair);

}
