package clsp.aligner;

import clsp.util.Alignment;
import clsp.util.SentencePair;
import clsp.util.Logger;

public class ThresholdAligner implements WordAligner {

	Model forwardModel, reverseModel;
	double threshold;

	public ThresholdAligner(Model forwardModel, Model reverseModel, double threshold) {
		this.forwardModel = forwardModel;
		this.reverseModel = reverseModel;
		this.threshold = threshold;
	}

	public Alignment alignSentencePair(SentencePair pair) {
		Model model = forwardModel;
		if (model == null) model = reverseModel;
		Alignment al = model.score(pair);
		return al.thresholdPosteriors(al.getPosteriors(), threshold);
	}

}
